﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FarseerGames.FarseerPhysics;
using DemoBaseXNA;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Labyrinth_Shooter.Base.Screens
{
    class PhysicsScreen : GameScreen
    {
        PhysicsSimulator _physicsSimulator;
        public PhysicsSimulator PhysicsSimulator
        {
            get { return _physicsSimulator; }
        }

        PhysicsSimulatorView physicsViewer;

        public override void Init(ScreenManager owner)
        {
            base.Init(owner);

            _physicsSimulator = new PhysicsSimulator(Vector2.Zero);
            physicsViewer = new PhysicsSimulatorView(_physicsSimulator);

            physicsViewer.LoadContent(owner.Owner.GraphicsDevice, owner.Owner.Content);
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);

            _physicsSimulator.Update(gameTime.ElapsedGameTime.Milliseconds * 0.001f);
        }

        public override void Draw(SpriteBatch spriteBatch)
        {
            base.Draw(spriteBatch);

            physicsViewer.Draw(spriteBatch);
        }

        public void AddEntity(DrawablePhysicsEntity entity)
        {
            entity.Init(this);
            entity.InitPhysics(_physicsSimulator);
            _entities.Add(entity);
        }
    }
}
