﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics;

namespace Labyrinth_Shooter
{
    class ScreenManager
    {
        LabyrinthShooter _owner;
        public LabyrinthShooter Owner
        {
            get { return _owner; }
        }


        List<GameScreen> _gameScreens = new List<GameScreen>();

        public ScreenManager(LabyrinthShooter owner)
        {
            _owner = owner;
        }

        public void Init()
        {
        }

        public void AddScreen(GameScreen screen)
        {
            screen.Init(this);
            _gameScreens.Add(screen);
        }

        public void RemoveScreen(GameScreen screen)
        {
            _gameScreens.Remove(screen);
        }

        public void Update(GameTime gameTime)
        {
            List<GameScreen> screensToUpdate = new List<GameScreen>();

            foreach (GameScreen screen in _gameScreens)
            {
                if (screen.isUpdate)
                {
                    screensToUpdate.Add(screen);
                }
            }

            foreach (GameScreen screen in screensToUpdate)
            {
                screen.Update(gameTime);
            }
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            List<GameScreen> screensToDraw = new List<GameScreen>();

            foreach (GameScreen screen in _gameScreens)
            {
                if (screen.isDraw)
                {
                    screensToDraw.Add(screen);
                }
            }

            foreach (GameScreen screen in screensToDraw)
            {
                screen.Draw(spriteBatch);
            }
        }
    }
}
