#include "StdAfx.h"

#include "GameWindow.h"

namespace Zeta
{
	namespace GameEngine
	{
		GameWindow::GameWindow(Windows::WindowClass *windowClass, LPCWSTR title)
		{
			// create the window and use the result as the handle
		#ifdef FULLSCREEN
			hWnd = CreateWindowEx(NULL,
								  windowClass->getClassName(),
								  title,
								  WS_EX_TOPMOST | WS_POPUP,    // fullscreen values
								  0, 0,    // the starting x and y positions should be 0
								  SCREEN_WIDTH, SCREEN_HEIGHT,
								  NULL,
								  NULL,
								  windowClass->getInstance(),
								  this);
		#else
			hWnd = CreateWindowEx(NULL,
								  windowClass->getClassName(),
								  //L"WindowClass1",    // name of the window class
								  title,    // title of the window
								  WS_OVERLAPPEDWINDOW,    // window style
								  300,    // x-position of the window
								  300,    // y-position of the window
								  500,    // width of the window
								  400,    // height of the window
								  NULL,    // we have no parent window, NULL
								  NULL,    // we aren't using menus, NULL
								  windowClass->getInstance(),
								  //hInstance,    // application handle
								  this);    // used with multiple windows, NULL
		#endif
		}

		GameWindow::~GameWindow(void)
		{
		}

		// This is the member window procedure
		// It terminates message loop when window is closed, and paints Hello, World! when requested by Windows
		LRESULT CALLBACK GameWindow::WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
		{
		// sort through and find what code to run for the message given
			switch(message)
			{
				// this message is read when the window is closed
				case WM_DESTROY:
					{
						// close the application entirely
						PostQuitMessage(0);
						return 0;
					} break;
			}

			// Handle any messages the switch statement didn't
			return DefWindowProc (hWnd, message, wParam, lParam);
		}
	}
}