#include "StdAfx.h"
#include "MessageHandler.h"

namespace Zeta
{
	namespace Windows
	{
		MessageHandler::MessageHandler(void)
		{
		}

		MessageHandler::~MessageHandler(void)
		{
		}

		WPARAM MessageHandler::StartPeek()
		{
			return StartPeek(NULL);
		}

		WPARAM MessageHandler::StartPeek(PeekHandler *Processor)
		{
			// enter the main loop:
			// this struct holds Windows event messages
			MSG message;
			BOOL isRunning = TRUE;

			// Enter the infinite message loop
			while(isRunning)
			{
				// Check to see if any messages are waiting in the queue
				while(PeekMessage(&message, NULL, 0, 0, PM_REMOVE))
				{
					// translate keystroke messages into the right format
					TranslateMessage(&message);

					// send the message to the WindowProc function
					DispatchMessage(&message);
				}

				// If the message is WM_QUIT, exit the while loop
				if(message.message == WM_QUIT)
					isRunning = FALSE;

				// Run game code here
				// ...
				// ...
				if(Processor != NULL && Processor->Process() == FALSE)
				{
					isRunning = FALSE;
				}
			}

			// return this part of the WM_QUIT message to Windows
			return message.wParam;
		}

		WPARAM MessageHandler::StartGet()
		{
			// enter the main loop:
			// this struct holds Windows event messages
			MSG message;

			// wait for the next message in the queue, store the result in 'msg'
			while(GetMessage(&message, NULL, 0, 0))
			{
				// translate keystroke messages into the right format
				TranslateMessage(&message);

				// send the message to the WindowProc function
				DispatchMessage(&message);
			}

			// return this part of the WM_QUIT message to Windows
			return message.wParam;
		}
	}
}